/* This file is part of ESS++.
 *      Copyright (c) Marc Chadeau (m.chadeau@imperial.ac.uk)
 *                    Leonardo Bottolo (l.bottolo@imperial.ac.uk)
 *                    David Hastie (d.hastie@imperial.ac.uk)
 *      2010
 *
 * ESS++ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ESS++ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ESS++.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <cassert>
#include <cmath>
#include <iostream>
#include <vector>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_matrix.h>
#include <stdint.h> 

using namespace std;

double myrand();

void smyrand( long seed );

double gennor(double av,double sd);

int genBernoulli( double p );

void My_Permut_unsigned_int(gsl_permutation *MyPerm);

int SampleFromDiscrete_All_exchange(gsl_matrix *description_all_exchange);

unsigned int SampleFromDiscrete_non_cum(vector<double> &pbty);

unsigned int SampleFromDiscrete_new( vector<double> &cdf );

void My_gsl_ran_choose_double(void * dest, size_t k, void * source, size_t n);

void My_gsl_ran_choose_u_int(void * dest, size_t k, void * source, size_t n);
